/*
 * trace.c
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1996,1993,1991,1990  Arizona Board of Regents
 *
 * $Revision: 1.2 $
 * $Date: 1996/04/25 20:57:17 $
 * 
 * HISTORY 
 * $Log: trace.c,v $
 * Revision 1.2  1996/04/25  20:57:17  slm
 * Updated copyright and version.
 *
 * Revision 1.1  1995/07/28  22:50:43  slm
 * Initial revision
 *
 * Revision 1.1  1994/10/26  20:41:50  hkaram
 * Initial revision
 */

#include "platform.h"
#include "xk_debug.h"
#include "compose.h"

#ifdef XK_TRACE_LOCKING
static pthread_mutex_t lock;
#endif

void
xTraceLock(void)
{
#ifdef XK_TRACE_LOCKING
    pthread_mutex_lock( &lock );
#endif
}

void
xTraceUnlock(void)
{
#ifdef XK_TRACE_LOCKING
    pthread_mutex_unlock( &lock );
#endif
}

 

void
xTraceInit(void)
{
#ifdef XK_TRACE_LOCKING
    pthread_mutex_init( &lock, NULL );
    initTraceLevels();
#endif
}

